// DAx22 Program to Test "libdax22_64.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "libdax22_64.h"

int main(void) 
{
   DWORD NumCards = 0;
//   DWORD CardNum = 1;
//   DWORD Chan = 1;
   int x;
   double Actual_Frequency;
   WORD TempArray[8000];
   DWORD MemoryDepth = 512;
   double pi = 3.14159265358979;
   
   
//------------------------------------------------------------------------------
// CREATE SAMPLE SINEWAVE TO UPLOAD
//------------------------------------------------------------------------------
   for (x=0; x < (MemoryDepth); x++) {
      TempArray[x] = (unsigned int) ( ceil( 2047.5 + 2047.5*sin( 2.0*pi* x/(32) ) ) );
   }
   
   printf("\nTempArray loaded with Sinewave.\n\r");
   printf("Hit key to continue ...\n\n\r");
   getchar();
   
   
//------------------------------------------------------------------------------
// CHECK IF CARD DETECTED; IF NOT THEN EXIT PROGRAM
//------------------------------------------------------------------------------

	NumCards = DAx22000_GetNumCards();

	printf("Number of Cards Detected = %lu \n\r", NumCards);
	printf("Hit key to continue ...\n\n\r");
	getchar();

	if (NumCards != 1) exit(0);
	
   
//------------------------------------------------------------------------------
// OPEN DRIVER, INITIALIZE, SET CLOCK RATE
//------------------------------------------------------------------------------

   x = DAx22000_Open(1);
   
   printf("DAx22000_Open = %i\n\r", x);
   printf("Hit key to continue ...\n\n\r");
   getchar();
   
   x = DAx22000_Initialize(1);
   
   printf("DAx22000_Initialize = %i\n\r", x);
   printf("Hit key to continue ...\n\n\r");
   getchar();
   
   Actual_Frequency = DAx22000_SetClkRate(1, 2.0e9);
   
   printf("DAx22000_SetClkRate = %1.2e\n\r", Actual_Frequency);
   printf("Hit key to continue ...\n\n\r");
   getchar();
   

//------------------------------------------------------------------------------
// UPLOAD USER WAVEFORM
//------------------------------------------------------------------------------
  
   x = DAx22000_CreateSingleSegment(
      1,           // DWORD CardNum
      1,           // DWORD ChanNum
      256,         // DWORD NumPoints, 
      0,           // DWORD NumLoops,        // 0 = Continuous Loop
      2047,        // DWORD PAD_Val_Beg, 
      2047,        // DWORD PAD_Val_End,
      TempArray,   // PVOID pUserArrayWORD, 
      1            // DWORD Triggered        // 1 = User can initiate "NumLoops" above by 
   );                                        //     triggering externally or SoftTrigger.
   
   printf("DAx22000_CreateSingleSegment = %i\n\r", x);
   printf("Hit key to continue ...\n\n\r");
   getchar();


//------------------------------------------------------------------------------
// OUTPUT DATA
//------------------------------------------------------------------------------

   DAx22000_Run(1, true);
   
   printf("Outputing Data.\n\r");
   printf("Hit key to turn off output.\n\n\r");
   getchar();
   
   DAx22000_Stop(1);
   
      
//------------------------------------------------------------------------------
// STOP OUTPUT AND CLOSE DRIVER
//------------------------------------------------------------------------------

   printf("Hit key to turn power off.\n\n\r");
   getchar();
   
   DAx22000_PWR_DWN(1);  
   DAx22000_Close(1);
  
}
