//---------------------------------------------------------------------------
#ifndef libdax22_64h
#define libdax22_64h
//---------------------------------------------------------------------------

#define DWORD unsigned long    // Use any of these if not defined.
#define WORD unsigned short    // 
#define BYTE unsigned char         //
#define PVOID void *               //

typedef int bool;
#define true 1
#define false 0

//---------------------------------------------------------------------------
//  USER ROUTINES
//---------------------------------------------------------------------------

#define IMPORT extern

IMPORT int DAx22000_GetNumCards(void);
IMPORT int DAx22000_Open(int CardNum);
IMPORT int DAx22000_Close(int CardNum);

IMPORT int DAx22000_Initialize(int CardNum);

IMPORT double DAx22000_SetClkRate(int CardNum, double User_Freq);
IMPORT int DAx22000_SelExtTrig(int CardNum, bool ExtTrig);

IMPORT int DAx22000_Run(int CardNum, bool TriggerNow);
IMPORT int DAx22000_Stop(int CardNum);

IMPORT int DAx22000_SoftTrigger(int CardNum);
IMPORT int DAx22000_Place_MRK2(int CardNum, int Mod16_CNT);

IMPORT int DAx22000_CreateSingleSegment(
   DWORD CardNum, 
   DWORD ChanNum, 
   DWORD NumPoints, 
   DWORD NumLoops, 
   DWORD PAD_Val_Beg, 
   DWORD PAD_Val_End,
   PVOID pUserArrayWORD, 
   DWORD Triggered
   );

IMPORT int DAx22000_CreateSegments(
   DWORD CardNum, 
   DWORD ChanNum, 
   DWORD NumSegments, 
   DWORD PAD_Val_Beg, 
   DWORD PAD_Val_End,
   PVOID pSegmentsList,
   bool Loop
   );

IMPORT int DAx22000_Debug(int CardNum, int ModeNum);

IMPORT int DAx22000_PWR_DWN(int CardNum);

IMPORT int DAx22000_Ext10MHz(int CardNum, int Enable);

IMPORT DWORD DAx_SerNum(DWORD CardNum);

#endif
